#pragma once

#include "ofMain.h"
#include "Particle.hpp"
#include "Timer.hpp"

class ofApp : public ofBaseApp{

public:
    void setup();
    void update();
    void draw();
    void addParticles(int count);
    void addParticle();
    void addTimer(float targetTime, std::function<void()> onTime);
    void refreshFriends();
    float calculateBeatToSeconds(int beat, float step);

    void keyPressed(int key);
     
private:
    ofSoundPlayer soundplayer;
    float * spectrum;
    const int audioSpectrumBands = 32;
    vector<Particle> particles;
    
    bool started = false;
    bool ended = false;
    float startingTime = 0;
    float tailLength = 0;
    float particleSize = 0;
    float spectrumSum = 0;
    float speedMultiplier = 1;
    
    vector<Timer> timers;
};
